# Class PasswordView

java.lang.Object
javax.swing.text.View
javax.swing.text.PlainView
javax.swing.text.FieldView
javax.swing.text.PasswordView

All Implemented Interfaces:
  `SwingConstants, TabExpander`

public class PasswordView extends FieldView
Implements a View suitable for use in JPasswordField UI implementations. This is basically a field ui that renders its contents as the echo character specified in the associated component (if it can narrow the component to a JPasswordField).

See Also:
  - `View`

- ## Field Summary

  ### Fields declared in class PlainView

  `metrics`
  Modifier and Type
  Field
  Description
  `protected FontMetrics`
  `metrics`
  Font metrics for the current font.

  ### Fields declared in class View

  `BadBreakWeight, ExcellentBreakWeight, ForcedBreakWeight, GoodBreakWeight, X_AXIS, Y_AXIS`
  Modifier and Type
  Field
  Description
  `static final int`
  `BadBreakWeight`
  The weight to indicate a view is a bad break opportunity for the purpose of formatting.
  `static final int`
  `ExcellentBreakWeight`
  The weight to indicate a view supports breaking, and this represents a very attractive place to break.
  `static final int`
  `ForcedBreakWeight`
  The weight to indicate a view supports breaking, and must be broken to be represented properly when placed in a view that formats its children by breaking them.
  `static final int`
  `GoodBreakWeight`
  The weight to indicate a view supports breaking, but better opportunities probably exist.
  `static final int`
  `X_AXIS`
  Axis for format/break operations.
  `static final int`
  `Y_AXIS`
  Axis for format/break operations.

  ### Fields declared in interface SwingConstants

  `BOTTOM, CENTER, EAST, HORIZONTAL, LEADING, LEFT, NEXT, NORTH, NORTH_EAST, NORTH_WEST, PREVIOUS, RIGHT, SOUTH, SOUTH_EAST, SOUTH_WEST, TOP, TRAILING, VERTICAL, WEST`
  Modifier and Type
  Field
  Description
  `static final int`
  `BOTTOM`
  Box-orientation constant used to specify the bottom of a box.
  `static final int`
  `CENTER`
  The central position in an area.
  `static final int`
  `EAST`
  Compass-direction east (right).
  `static final int`
  `HORIZONTAL`
  Horizontal orientation.
  `static final int`
  `LEADING`
  Identifies the leading edge of text for use with left-to-right and right-to-left languages.
  `static final int`
  `LEFT`
  Box-orientation constant used to specify the left side of a box.
  `static final int`
  `NEXT`
  Identifies the next direction in a sequence.
  `static final int`
  `NORTH`
  Compass-direction North (up).
  `static final int`
  `NORTH_EAST`
  Compass-direction north-east (upper right).
  `static final int`
  `NORTH_WEST`
  Compass-direction north west (upper left).
  `static final int`
  `PREVIOUS`
  Identifies the previous direction in a sequence.
  `static final int`
  `RIGHT`
  Box-orientation constant used to specify the right side of a box.
  `static final int`
  `SOUTH`
  Compass-direction south (down).
  `static final int`
  `SOUTH_EAST`
  Compass-direction south-east (lower right).
  `static final int`
  `SOUTH_WEST`
  Compass-direction south-west (lower left).
  `static final int`
  `TOP`
  Box-orientation constant used to specify the top of a box.
  `static final int`
  `TRAILING`
  Identifies the trailing edge of text for use with left-to-right and right-to-left languages.
  `static final int`
  `VERTICAL`
  Vertical orientation.
  `static final int`
  `WEST`
  Compass-direction west (left).

- ## Constructor Summary

  Constructors
  Constructor
  Description
  `PasswordView(Element elem)`
  Constructs a new view wrapped on an element.

- ## Method Summary

  Modifier and Type
  Method
  Description
  `protected float`
  `drawEchoCharacter(Graphics2D g, float x, float y, char c)`
  Renders the echo character, or whatever graphic should be used to display the password characters.
  `protected int`
  `drawEchoCharacter(Graphics g, int x, int y, char c)`
  Deprecated.
  replaced by `drawEchoCharacter(Graphics2D, float, float, char)`
  `protected int`
  `drawSelectedText(Graphics g, int x, int y, int p0, int p1)`
  Deprecated.
  replaced by `PlainView.drawSelectedText(Graphics2D, float, float, int, int)`
  `protected int`
  `drawUnselectedText(Graphics g, int x, int y, int p0, int p1)`
  Deprecated.
  replaced by `PlainView.drawUnselectedText(Graphics2D, float, float, int, int)`
  `float`
  `getPreferredSpan(int axis)`
  Determines the preferred span for this view along an axis.
  `Shape`
  `modelToView(int pos, Shape a, Position.Bias b)`
  Provides a mapping from the document model coordinate space to the coordinate space of the view mapped to it.
  `int`
  `viewToModel(float fx, float fy, Shape a, Position.Bias[] bias)`
  Provides a mapping from the view coordinate space to the logical coordinate space of the model.

  ### Methods declared in class FieldView

  `adjustAllocation, getFontMetrics, getResizeWeight, insertUpdate, paint, removeUpdate`
  Modifier and Type
  Method
  Description
  `protected Shape`
  `adjustAllocation(Shape a)`
  Adjusts the allocation given to the view to be a suitable allocation for a text field.
  `protected FontMetrics`
  `getFontMetrics()`
  Fetches the font metrics associated with the component hosting this view.
  `int`
  `getResizeWeight(int axis)`
  Determines the resizability of the view along the given axis.
  `void`
  `insertUpdate(DocumentEvent changes, Shape a, ViewFactory f)`
  Gives notification that something was inserted into the document in a location that this view is responsible for.
  `void`
  `paint(Graphics g, Shape a)`
  Renders using the given rendering surface and area on that surface.
  `void`
  `removeUpdate(DocumentEvent changes, Shape a, ViewFactory f)`
  Gives notification that something was removed from the document in a location that this view is responsible for.

  ### Methods declared in class PlainView

  `changedUpdate, damageLineRange, drawLine, drawLine, drawSelectedText, drawUnselectedText, getLineBuffer, getTabSize, lineToRect, nextTabStop, setSize, updateDamage, updateMetrics`
  Modifier and Type
  Method
  Description
  `void`
  `changedUpdate(DocumentEvent changes, Shape a, ViewFactory f)`
  Gives notification from the document that attributes were changed in a location that this view is responsible for.
  `protected void`
  `damageLineRange(int line0, int line1, Shape a, Component host)`
  Repaint the given line range.
  `protected void`
  `drawLine(int lineIndex, Graphics2D g, float x, float y)`
  Renders a line of text, suppressing whitespace at the end and expanding any tabs.
  `protected void`
  `drawLine(int lineIndex, Graphics g, int x, int y)`
  Deprecated.
  replaced by `PlainView.drawLine(int, Graphics2D, float, float)`
  `protected float`
  `drawSelectedText(Graphics2D g, float x, float y, int p0, int p1)`
  Renders the given range in the model as selected text.
  `protected float`
  `drawUnselectedText(Graphics2D g, float x, float y, int p0, int p1)`
  Renders the given range in the model as normal unselected text.
  `protected final Segment`
  `getLineBuffer()`
  Gives access to a buffer that can be used to fetch text from the associated document.
  `protected int`
  `getTabSize()`
  Returns the tab size set for the document, defaulting to 8.
  `protected Rectangle`
  `lineToRect(Shape a, int line)`
  Determine the rectangle that represents the given line.
  `float`
  `nextTabStop(float x, int tabOffset)`
  Returns the next tab stop position after a given reference position.
  `void`
  `setSize(float width, float height)`
  Sets the size of the view.
  `protected void`
  `updateDamage(DocumentEvent changes, Shape a, ViewFactory f)`
  Repaint the region of change covered by the given document event.
  `protected void`
  `updateMetrics()`
  Checks to see if the font metrics and longest line are up-to-date.

  ### Methods declared in class View

  `append, breakView, createFragment, forwardUpdate, forwardUpdateToView, getAlignment, getAttributes, getBreakWeight, getChildAllocation, getContainer, getDocument, getElement, getEndOffset, getGraphics, getMaximumSpan, getMinimumSpan, getNextVisualPositionFrom, getParent, getStartOffset, getToolTipText, getView, getViewCount, getViewFactory, getViewIndex, getViewIndex, insert, isVisible, modelToView, modelToView, preferenceChanged, remove, removeAll, replace, setParent, updateChildren, updateLayout, viewToModel`
  Modifier and Type
  Method
  Description
  `void`
  `append(View v)`
  Appends a single child view.
  `View`
  `breakView(int axis, int offset, float pos, float len)`
  Tries to break this view on the given axis.
  `View`
  `createFragment(int p0, int p1)`
  Creates a view that represents a portion of the element.
  `protected void`
  `forwardUpdate(DocumentEvent.ElementChange ec, DocumentEvent e, Shape a, ViewFactory f)`
  Forwards the given `DocumentEvent` to the child views that need to be notified of the change to the model.
  `protected void`
  `forwardUpdateToView(View v, DocumentEvent e, Shape a, ViewFactory f)`
  Forwards the `DocumentEvent` to the give child view.
  `float`
  `getAlignment(int axis)`
  Determines the desired alignment for this view along an axis.
  `AttributeSet`
  `getAttributes()`
  Fetches the attributes to use when rendering.
  `int`
  `getBreakWeight(int axis, float pos, float len)`
  Determines how attractive a break opportunity in this view is.
  `Shape`
  `getChildAllocation(int index, Shape a)`
  Fetches the allocation for the given child view.
  `Container`
  `getContainer()`
  Fetches the container hosting the view.
  `Document`
  `getDocument()`
  Fetches the model associated with the view.
  `Element`
  `getElement()`
  Fetches the structural portion of the subject that this view is mapped to.
  `int`
  `getEndOffset()`
  Fetches the portion of the model for which this view is responsible.
  `Graphics`
  `getGraphics()`
  Fetch a `Graphics` for rendering.
  `float`
  `getMaximumSpan(int axis)`
  Determines the maximum span for this view along an axis.
  `float`
  `getMinimumSpan(int axis)`
  Determines the minimum span for this view along an axis.
  `int`
  `getNextVisualPositionFrom(int pos, Position.Bias b, Shape a, int direction, Position.Bias[] biasRet)`
  Provides a way to determine the next visually represented model location at which one might place a caret.
  `View`
  `getParent()`
  Returns the parent of the view.
  `int`
  `getStartOffset()`
  Fetches the portion of the model for which this view is responsible.
  `String`
  `getToolTipText(float x, float y, Shape allocation)`
  Returns the tooltip text at the specified location.
  `View`
  `getView(int n)`
  Gets the nth child view.
  `int`
  `getViewCount()`
  Returns the number of views in this view.
  `ViewFactory`
  `getViewFactory()`
  Fetches the `ViewFactory` implementation that is feeding the view hierarchy.
  `int`
  `getViewIndex(float x, float y, Shape allocation)`
  Returns the child view index representing the given position in the view.
  `int`
  `getViewIndex(int pos, Position.Bias b)`
  Returns the child view index representing the given position in the model.
  `void`
  `insert(int offs, View v)`
  Inserts a single child view.
  `boolean`
  `isVisible()`
  Returns a boolean that indicates whether the view is visible or not.
  `Shape`
  `modelToView(int pos, Shape a)`
  Deprecated.
  `Shape`
  `modelToView(int p0, Position.Bias b0, int p1, Position.Bias b1, Shape a)`
  Provides a mapping, for a given region, from the document model coordinate space to the view coordinate space.
  `void`
  `preferenceChanged(View child, boolean width, boolean height)`
  Child views can call this on the parent to indicate that the preference has changed and should be reconsidered for layout.
  `void`
  `remove(int i)`
  Removes one of the children at the given position.
  `void`
  `removeAll()`
  Removes all of the children.
  `void`
  `replace(int offset, int length, View[] views)`
  Replaces child views.
  `void`
  `setParent(View parent)`
  Establishes the parent view for this view.
  `protected boolean`
  `updateChildren(DocumentEvent.ElementChange ec, DocumentEvent e, ViewFactory f)`
  Updates the child views in response to receiving notification that the model changed, and there is change record for the element this view is responsible for.
  `protected void`
  `updateLayout(DocumentEvent.ElementChange ec, DocumentEvent e, Shape a)`
  Updates the layout in response to receiving notification of change from the model.
  `int`
  `viewToModel(float x, float y, Shape a)`
  Deprecated.

  ### Methods declared in class Object

  `clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`
  Modifier and Type
  Method
  Description
  `protected Object`
  `clone()`
  Creates and returns a copy of this object.
  `boolean`
  `equals(Object obj)`
  Indicates whether some other object is "equal to" this one.
  `protected void`
  `finalize()`
  Deprecated, for removal: This API element is subject to removal in a future version.
  Finalization is deprecated and subject to removal in a future release.
  `final Class<?>`
  `getClass()`
  Returns the runtime class of this `Object`.
  `int`
  `hashCode()`
  Returns a hash code value for this object.
  `final void`
  `notify()`
  Wakes up a single thread that is waiting on this object's monitor.
  `final void`
  `notifyAll()`
  Wakes up all threads that are waiting on this object's monitor.
  `String`
  `toString()`
  Returns a string representation of the object.
  `final void`
  `wait()`
  Causes the current thread to wait until it is awakened, typically by being notified or interrupted.
  `final void`
  `wait(long timeoutMillis)`
  Causes the current thread to wait until it is awakened, typically by being notified or interrupted, or until a certain amount of real time has elapsed.
  `final void`
  `wait(long timeoutMillis, int nanos)`
  Causes the current thread to wait until it is awakened, typically by being notified or interrupted, or until a certain amount of real time has elapsed.

- ## Constructor Details

  - ### PasswordView

    public PasswordView(Element elem)
    Constructs a new view wrapped on an element.
    Parameters:
      `elem` - the element

- ## Method Details

  - ### drawUnselectedText

    @Deprecated(since="9") protected int drawUnselectedText(Graphics g, int x, int y, int p0, int p1) throws BadLocationException
    Deprecated.
    replaced by `PlainView.drawUnselectedText(Graphics2D, float, float, int, int)`
    Renders the given range in the model as normal unselected text. This sets the foreground color and echos the characters using the value returned by getEchoChar().
    Overrides:
      `drawUnselectedText` in class `PlainView`
    Parameters:
      `g` - the graphics context
      `x` - the starting X coordinate >= 0
      `y` - the starting Y coordinate >= 0
      `p0` - the starting offset in the model >= 0
      `p1` - the ending offset in the model >= p0
    Returns:
      the X location of the end of the range >= 0
    Throws:
      `BadLocationException` - if p0 or p1 are out of range

  - ### drawSelectedText

    @Deprecated(since="9") protected int drawSelectedText(Graphics g, int x, int y, int p0, int p1) throws BadLocationException
    Deprecated.
    replaced by `PlainView.drawSelectedText(Graphics2D, float, float, int, int)`
    Renders the given range in the model as selected text. This is implemented to render the text in the color specified in the hosting component. It assumes the highlighter will render the selected background. Uses the result of getEchoChar() to display the characters.
    Overrides:
      `drawSelectedText` in class `PlainView`
    Parameters:
      `g` - the graphics context
      `x` - the starting X coordinate >= 0
      `y` - the starting Y coordinate >= 0
      `p0` - the starting offset in the model >= 0
      `p1` - the ending offset in the model >= p0
    Returns:
      the X location of the end of the range >= 0
    Throws:
      `BadLocationException` - if p0 or p1 are out of range

  - ### drawEchoCharacter

    @Deprecated(since="9") protected int drawEchoCharacter(Graphics g, int x, int y, char c)
    Deprecated.
    replaced by `drawEchoCharacter(Graphics2D, float, float, char)`
    Renders the echo character, or whatever graphic should be used to display the password characters. The color in the Graphics object is set to the appropriate foreground color for selected or unselected text.
    Parameters:
      `g` - the graphics context
      `x` - the starting X coordinate >= 0
      `y` - the starting Y coordinate >= 0
      `c` - the echo character
    Returns:
      the updated X position >= 0

  - ### drawEchoCharacter

    protected float drawEchoCharacter(Graphics2D g, float x, float y, char c)
    Renders the echo character, or whatever graphic should be used to display the password characters. The color in the Graphics object is set to the appropriate foreground color for selected or unselected text.
    Parameters:
      `g` - the graphics context
      `x` - the starting X coordinate `>= 0`
      `y` - the starting Y coordinate `>= 0`
      `c` - the echo character
    Returns:
      the updated X position `>= 0`
    Since:
      9

  - ### modelToView

    public Shape modelToView(int pos, Shape a, Position.Bias b) throws BadLocationException
    Provides a mapping from the document model coordinate space to the coordinate space of the view mapped to it.
    Overrides:
      `modelToView` in class `FieldView`
    Parameters:
      `pos` - the position to convert >= 0
      `a` - the allocated region to render into
      `b` - the bias toward the previous character or the next character represented by the offset, in case the position is a boundary of two views; `b` will have one of these values:
      - `Position.Bias.Forward`
      - `Position.Bias.Backward`
    Returns:
      the bounding box of the given position
    Throws:
      `BadLocationException` - if the given position does not represent a valid location in the associated document
    See Also:
      - `View.modelToView(int, Shape, Position.Bias)`

  - ### viewToModel

    public int viewToModel(float fx, float fy, Shape a, Position.Bias[] bias)
    Provides a mapping from the view coordinate space to the logical coordinate space of the model.
    Overrides:
      `viewToModel` in class `FieldView`
    Parameters:
      `fx` - the X coordinate >= 0.0f
      `fy` - the Y coordinate >= 0.0f
      `a` - the allocated region to render into
      `bias` - the returned bias
    Returns:
      the location within the model that best represents the given point in the view
    See Also:
      - `View.viewToModel(float, float, Shape, Position.Bias[])`

  - ### getPreferredSpan

    public float getPreferredSpan(int axis)
    Determines the preferred span for this view along an axis.
    Overrides:
      `getPreferredSpan` in class `FieldView`
    Parameters:
      `axis` - may be either View.X_AXIS or View.Y_AXIS
    Returns:
      the span the view would like to be rendered into >= 0. Typically the view is told to render into the span that is returned, although there is no guarantee. The parent may choose to resize or break the view.